# -*- coding: utf-8 -*-
# @Time : 2023/7/20 17:41
# @Author : XuJiakai
# @File : dim_template_class
# @Software: PyCharm
from abc import abstractmethod


class DimTemplateClass:
    def __init__(self):
        pass

    @abstractmethod
    async def _exec_row(self, row_data: dict):
        raise NotImplementedError

    async def _prefix_func(self, dim_data: list):
        pass

    async def _postfix_func(self, dim_data: list):
        pass

    async def execute_dim(self, dim_data: list):
        await self._prefix_func(dim_data)

        result_list = []
        for row in dim_data:
            row_data = await self._exec_row(row)
            if row_data is not None:
                result_list.append(row_data)

        if len(result_list) > 0:
            await self._prefix_func(result_list)

        return result_list


if __name__ == '__main__':
    pass
