# -*- coding: utf-8 -*-
# @Time : 2023/7/20 17:04
# @Author : XuJiakai
# @File : task_distributor
# @Software: PyCharm

import data_clean.handle

func_dict = {
    "company_court_open_announcement": data_clean.handle.company_court_open_announcement.CompanyCourtOpenAnnouncement()
}


async def task_distribute(data: dict):
    """
    该函数用于维度的分发处理
    :param data:
    :return:
    """
    tmp_data = data['data']

    for key in set(tmp_data.keys()):
        if key in func_dict:
            result_data = await func_dict[key].execute_dim(tmp_data[key])
            if len(result_data) == 0:
                del tmp_data[key]
            else:
                tmp_data[key] = result_data

        else:
            raise ValueError(f"{key} 维度未实现！")

    if len(tmp_data) == 0:
        return None

    return data


if __name__ == '__main__':
    pass
